Global JNKM_inst[50]
Global JNKM_BeatAt,JNKM_Tempo,JNKM_Chord$,JNKM_PatternLength,JNKM_SongSeed,JNKM_SongRules,JNKM_Playing
Global JNKM_StereoSeperation#

Global JNKM_RowAt,JNKM_PatternAt,JNKM_SongAt
Global JNKM_Pattern#[1300] '20 columns, 64 rows, bit extra to prevent overspill
Global JNKM_PatternUse[5],JNKM_PatternHave[5]

Global JNKM_PatternCmd[1300]

Global JNKM_Mute[20],JNKM_MuteAhead[20],JNKM_MuteAheadGo[20]

Global JNKM_DrumloopA$,JNKM_DrumloopB$
Global JNKM_BassBeat$,JNKM_MelodyBeat$,JNKM_MelodyBeatB$

Global JNKM_Set$[5000],JNKM_Many[5],JNKM_Stretch[5]


' Testing purposes
'Graphics 800,600
'ChangeDir "files/"
'ChangeDir "234/"
'JNKM_Load()
'JNKM_NewSong(1,100)
'Repeat
'	JNKM_Play()
'Until MouseDown(1)


Function JNKM_Load()
	For n=1 To 8
		JNKM_inst[n]=LoadSound("music/d1-"+n+".wav")
		JNKM_inst[n+10]=LoadSound("music/d2-"+n+".wav")
		If FileType("music/bass"+n+".wav") Then JNKM_PatternHave[1]=n;JNKM_inst[n+20]=LoadSound("music/bass"+n+".wav")
		If FileType("music/lead"+n+".wav") Then JNKM_PatternHave[2]=n;JNKM_inst[n+30]=LoadSound("music/lead"+n+".wav")	
		If FileType("music/accompany"+n+".wav") Then JNKM_PatternHave[3]=n;JNKM_inst[n+40]=LoadSound("music/accompany"+n+".wav")	
	Next
	
End Function

Function JNKM_Pan(fnf#)
	JNKM_StereoSeperation#=fnf#
End Function


Function JNKM_NewSong(Track$,seed:Int=-1,tempo:Int=125)
For fn=0 To 4;JNKM_Many[fn]=0;JNKM_Stretch[fn]=-1;Next
Local intopos=-1

If FileType("music/"+track$+".ini")

	quicky=ReadFile("music/"+track$+".ini")
		Repeat
			in$=Trim$(ReadLine(quicky))
			If Left$(in$,1)="["
				ftxt$=Replace$(Upper$(in$),"]","")
'				DebugLog ftxt$				
				If ftxt$="[DRUMS" Then intopos=0
				If ftxt$="[CHORDS" Then intopos=1
				If ftxt$="[BASS" Then intopos=2
				If ftxt$="[MELODY" Then intopos=3
				If ftxt$="[ACCOMPANY" Then intopos=4			
			EndIf
			
			If Left$(Upper$(in$),7)="STRETCH" And intopos>-1 And intopos<5
				If Right$(Upper$(in$),5)="FALSE" Then JNKM_Stretch[intopos]=0
				If Right$(Upper$(in$),6)="RANDOM" Then JNKM_Stretch[intopos]=1
				If Right$(Upper$(in$),7)="RANDOM+" Then JNKM_Stretch[intopos]=2
				If Right$(Upper$(in$),6)="DOUBLE" Then JNKM_Stretch[intopos]=-2
			EndIf
			
			If Left$(in$,1)=Chr$(34) And intopos>-1 And intopos<5
				ftxt$=Replace$(Trim$(in$),Chr$(34),"")
'				DebugLog intopos+":"+JNKM_Many[intopos]+":"+ftxt$
				JNKM_Many[intopos]=JNKM_Many[intopos]+1
				If JNKM_Many[intopos]<999 Then JNKM_Set$[JNKM_Many[intopos]+(intopos*1000)]=ftxt$
			EndIf
		Until Eof(quicky)
	CloseFile quicky
	
	SeedRnd seed*1024;If seed=-1 Then seed=MilliSecs();SeedRnd seed*1024
	JNKM_SongSeed=Seed

	JNKM_SongRules=Group
	JNKM_StereoSeperation#=.3
	JNKM_PatternLength=2'Rand(1,2)*2
	JNKM_Chord$=""
	JNKM_SongAt=-1
	JNKM_PatternAt=-1
	JNKM_RowAt=-1
	JNKM_BeatAt=MilliSecs()
	JNKM_Tempo=tempo/2	
	For n=0 To 19;JNKM_MuteAhead[n]=Rand(0,1);Next
	

	JNKM_NextPattern()
	JNKM_BeatAt=MilliSecs()+250
	JNKM_Playing=1
EndIf

End Function

Function JNKM_Stop()
	JNKM_Playing=0
	For n=0 To 19
		If Channel[n]<>0 Then If ChannelPlaying(Channel[n]) Then StopChannel channel[n]
		Channel[n]=0
	Next
	
End Function

Function JNKM_Play()
If JNKM_Playing
Local pitch#,chordpitch#,mute,over

	If JNKM_BeatAt<MilliSecs()
		JNKM_BeatAt=JNKM_BeatAt+JNKM_Tempo
		JNKM_RowAt=JNKM_RowAt+1
		If JNKM_RowAt=64 Then JNKM_RowAt=0;JNKM_NextPattern()
		
		over=0
		fc=((JNKM_RowAt/8)+((JNKM_PatternAt-1)*8))
		chordpitch#=JNKM_NoteVal(Mid$(JNKM_Chord$,fc+1,1))
		If fc=>(Len(JNKM_Chord$)*2)-1 Then over=2

		fc=((JNKM_RowAt/16)+((JNKM_PatternAt-1)*4))
		chordpitch#=JNKM_NoteVal(Mid$(JNKM_Chord$,fc+1,1))
		If fc=>Len(JNKM_Chord$)-1 And over=0 Then over=1
		
		
		
		' Pattern 0, Drumloop A
		fp=0
		fi=Int(JNKM_Pattern[(fp*70)+JNKM_RowAt])
		mute=JNKM_Mute[fp]
		If mute=1
			If over=1 And JNKM_MuteAheadGo[fp]=1 And JNKM_MuteAhead[fp]=0 Then mute=0
			If over=2 And JNKM_MuteAheadGo[fp]>0 And JNKM_MuteAhead[fp]=0 Then mute=0
		EndIf
		
		If fi>0 And fi<9 And mute=0
			If channel[fp]<>0 Then If ChannelPlaying(channel[fp]) Then StopChannel channel[fp];channel[fp]=0
			Channel[fp]=AllocChannel()
			CueSound(JNKM_inst[fi],Channel[fp])
			If Channel[fp]<>0	
				SetChannelPan Channel[fp],JNKM_StereoSeperation#	
				SetChannelVolume Channel[fp],(Float(Options[13]*Options[11])/100.0)/100
				ResumeChannel Channel[fp]			
			EndIf
			
		EndIf
		
		' Pattern 1, Drumloop B
		fp=1
		fi=Int(JNKM_Pattern[(fp*70)+JNKM_RowAt])
		mute=JNKM_Mute[fp]
		If mute=1
			If over=1 And JNKM_MuteAheadGo[fp]=1 And JNKM_MuteAhead[fp]=0 Then mute=0
			If over=2 And JNKM_MuteAheadGo[fp]>0 And JNKM_MuteAhead[fp]=0 Then mute=0
		EndIf
		
		If fi>0 And fi<9 And mute=0
			If channel[fp]<>0 Then If ChannelPlaying(channel[fp]) Then StopChannel channel[fp];channel[fp]=0
			Channel[fp]=AllocChannel()
			CueSound(JNKM_inst[fi+10],Channel[fp])
			If Channel[fp]<>0	
				SetChannelPan Channel[fp],-JNKM_StereoSeperation#	
				SetChannelVolume Channel[fp],(Float(Options[13]*Options[11])/100.0)/100
				ResumeChannel Channel[fp]			
			EndIf
		EndIf
		

		
		' Pattern 2, Bass A
		fp=2
		fif#=JNKM_Pattern[(fp*70)+JNKM_RowAt]
		mute=JNKM_Mute[fp]
		If mute=1 And JNKM_MuteAhead[fp]=0 And JNKM_MuteAheadGo[fp]>0 
			If over=1 And JNKM_MuteAheadGo[fp]=1 Then mute=0
			If over=2 Then mute=0
		EndIf
		
		If fif<>0 And mute=0
			If channel[fp]<>0 Then If ChannelPlaying(channel[fp]) Then StopChannel channel[fp];channel[fp]=0
			Channel[fp]=AllocChannel()
			CueSound(JNKM_Inst[20+JNKM_PatternUse[1]],Channel[fp])
			If Channel[fp]<>0	
				pitch#=fif*chordpitch
				SetChannelPan Channel[fp],-JNKM_StereoSeperation#
				SetChannelRate Channel[fp],pitch#
				SetChannelVolume Channel[fp],(Float(Options[13]*Options[11])/100.0)/100
				ResumeChannel Channel[fp]
			EndIf
		EndIf

		' Pattern 3, Lead
		fp=3
		fif#=JNKM_Pattern[(fp*70)+JNKM_RowAt]
		mute=JNKM_Mute[fp]
		If mute=1
			If over=1 And JNKM_MuteAheadGo[fp]=1 And JNKM_MuteAhead[fp]=0 Then mute=0
			If over=2 And JNKM_MuteAheadGo[fp]>0 And JNKM_MuteAhead[fp]=0 Then mute=0
		EndIf

		If fif<>0 And mute=0
			If channel[fp]<>0 Then If ChannelPlaying(channel[fp]) Then StopChannel channel[fp];channel[fp]=0
			Channel[fp]=AllocChannel()
			CueSound(JNKM_Inst[30+JNKM_PatternUse[2]],Channel[fp])
			If Channel[fp]<>0				
				pitch#=fif*chordpitch
				SetChannelRate Channel[fp],pitch#
				SetChannelVolume Channel[fp],(Float(Options[13]*Options[11])/100.0)/100
				ResumeChannel Channel[fp]
			EndIf
		EndIf

		' Pattern 4, Lead B
		fp=4
		fif#=JNKM_Pattern[(fp*70)+JNKM_RowAt]
		mute=JNKM_Mute[fp]
		If mute=1
			If over=1 And JNKM_MuteAheadGo[fp]=1 And JNKM_MuteAhead[fp]=0 Then mute=0
			If over=2 And JNKM_MuteAheadGo[fp]>0 And JNKM_MuteAhead[fp]=0 Then mute=0
		EndIf
		
		If fif<>0 And mute=0
			If channel[fp]<>0 Then If ChannelPlaying(channel[fp]) Then StopChannel channel[fp];channel[fp]=0
			Channel[fp]=AllocChannel()
			CueSound(JNKM_Inst[40+JNKM_PatternUse[3]],Channel[fp])
			If Channel[fp]<>0	
				pitch#=fif*chordpitch
				SetChannelPan Channel[fp],JNKM_StereoSeperation#			
				SetChannelRate Channel[fp],pitch#
				SetChannelVolume Channel[fp],(Float(Options[13]*Options[11])/100.0)/200
				ChannelVol[fp]=0.5
				ResumeChannel Channel[fp]
			EndIf
		EndIf

		
	EndIf
EndIf

End Function



Function JNKM_NextPattern()

Local JNKM_BassBeatAt$,JNKM_MelodyAt$
SeedRnd (JNKM_SongSeed*1024)+JNKM_PatternAt+JNKM_SongAt

	JNKM_SongAt=JNKM_SongAt+1
	JNKM_PatternAt=JNKM_PatternAt+1
	If JNKM_PatternAt>Len(JNKM_Chord$)/4 Or Len(JNKM_Chord$)=0
		JNKM_PatternUse[1]=Rand(1,JNKM_PatternHave[1])
		JNKM_PatternUse[2]=Rand(1,JNKM_PatternHave[2])
		JNKM_PatternUse[3]=Rand(1,JNKM_PatternHave[3])
		
		JNKM_PatternAt=1
		JNKM_Chord$=JNKM_Chords$(13)
		
		haveinstru=0
		For fn=0 To 19;
			JNKM_Mute[fn]=JNKM_MuteAhead[fn];
			JNKM_MuteAhead[fn]=Rand(0,1);
			JNKM_MuteAheadGo[fn]=Rand(1,2);
			If fn>1 And fn<4 And JNKM_Mute[fn]=0 Then haveinstru=1
		Next
		If JNKM_Mute[0] And JNKM_Mute[1]=1 Then JNKM_Mute[Rand(0,1)]=0
		If haveinstru=0 Then JNKM_Mute[Rand(2,3)]=0

		
		JNKM_DrumloopA$=JNKM_DrumLoop$(3);JNKM_DrumloopB$=JNKM_DrumLoop$(7)
		JNKM_BassBeat$=JNKM_BassRhythm$(13)	
		JNKM_MelodyBeat$=JNKM_MelodyTune$(19)
		JNKM_MelodyBeatB$=JNKM_AccompanyTune$(29)
	EndIf

	For fn=0 To 63
			JNKM_Pattern[(0*70)+fn]=Int(Mid$(JNKM_DrumLoopA$,(fn Mod Len(JNKM_DrumloopB$))+1,1))
			JNKM_Pattern[(1*70)+fn]=Int(Mid$(JNKM_DrumLoopB$,(fn Mod Len(JNKM_DrumloopB$))+1,1))

			JNKM_BassBeatAt$=Mid$(JNKM_BassBeat$,((fn+((JNKM_PatternAt-1)*64)) Mod Len(JNKM_BassBeat$))+1,1)
			JNKM_Pattern[(2*70)+fn]=0;If JNKM_BassBeatAt$<>" " Then JNKM_Pattern[(2*70)+fn]=JNKM_NoteVal#(JNKM_BassBeatAt$)

			JNKM_MelodyAt$=Mid$(JNKM_MelodyBeat$,((fn+((JNKM_PatternAt-1)*64)) Mod Len(JNKM_MelodyBeat$))+1,1)
			JNKM_Pattern[(3*70)+fn]=0;If JNKM_MelodyAt$<>" " Then JNKM_Pattern[(3*70)+fn]=JNKM_NoteVal#(JNKM_MelodyAt$);

			JNKM_MelodyAt$=Mid$(JNKM_MelodyBeatB$,((fn+((JNKM_PatternAt-1)*64)) Mod Len(JNKM_MelodyBeatB$))+1,1)
			JNKM_Pattern[(4*70)+fn]=0;If JNKM_MelodyAt$<>" " Then JNKM_Pattern[(4*70)+fn]=JNKM_NoteVal#(JNKM_MelodyAt$);
	Next

End Function


Function JNKM_DrumLoop$(skip)
' A preset selection of possible Drumloop patterns.
' Feel free to add more!
SeedRnd (JNKM_SongSeed*1024)+JNKM_PatternAt+JNKM_SongAt+skip
For fm=1 To (JNKM_SongAt*4)+skip;fn=Rand(0,1000);Next
	ftxt$=JNKM_Set$[Rand(1,JNKM_Many[0])]

	fs=Rand(0,2)
	ftxt2$=ftxt$
	
	' expand it's length..
	If (JNKM_Stretch[0]>0 And fs>0) Or (JNKM_Stretch[0]<0)
		ftxt2$=""	
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf
	
	' expand it's length..
	If (JNKM_Stretch[0]=2 And fs=2) Or (JNKM_Stretch[0]=-2)
		ftxt$=ftxt2$
		ftxt2$=""
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf
	
Return ftxt2$
End Function



Function JNKM_Chords$(skip)
' The basic repeating chord structure.

SeedRnd (JNKM_SongSeed*1024)+JNKM_PatternAt+JNKM_SongAt+skip
For fm=1 To (JNKM_SongAt*4)+skip;fn=Rand(0,1000);Next

	Return JNKM_Set$[Rand(1,JNKM_Many[1])+1000]
End Function


Function JNKM_BassRhythm$(skip)
' The rhythm that the bass line will tap out.
' This gets fitting alongside the chord structure to generate a nice underlying bassline.
SeedRnd (JNKM_SongSeed*1024)+JNKM_PatternAt+JNKM_SongAt+skip
For fm=1 To (JNKM_SongAt*4)+skip;fn=Rand(0,1000);Next
ftxt$="";ftxt2$=""

	ftxt$=JNKM_Set$[Rand(1,JNKM_Many[2])+2000]
	
	fs=Rand(0,2)
	
	ftxt2$=ftxt$
	
	' expand it's length..
	If (JNKM_Stretch[2]>0 And fs>0) Or (JNKM_Stretch[2]<0)
		ftxt2$=""	
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf
	
	' expand it's length..
	If (JNKM_Stretch[2]=2 And fs=2) Or (JNKM_Stretch[2]=-2)
		ftxt$=ftxt2$
		ftxt2$=""
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf


Return ftxt2$
End Function


Function JNKM_MelodyTune$(skip,stretch=1)
' The rhythm that the bass line will tap out.
' This gets fitting alongside the chord structure to generate a nice underlying bassline.
SeedRnd (JNKM_SongSeed*1024)+JNKM_PatternAt+JNKM_SongAt+skip
For fm=1 To (JNKM_SongAt*4)+skip;fn=Rand(0,1000);Next
ftxt$="";ftxt2$=""

	ftxt$=JNKM_Set$[Rand(1,JNKM_Many[3])+3000]
	
	fs=Rand(0,2)
	
	ftxt2$=ftxt$
	
	' expand it's length..
	If (JNKM_Stretch[3]>0 And fs>0) Or (JNKM_Stretch[3]<0)
		ftxt2$=""
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf
	
	' expand it's length..
	If (JNKM_Stretch[3]=2 And fs=2) Or (JNKM_Stretch[3]=-2)
		ftxt$=ftxt2$
		ftxt2$=""
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf


Return ftxt2$
End Function

Function JNKM_AccompanyTune$(skip)
' The rhythm that the bass line will tap out.
' This gets fitting alongside the chord structure to generate a nice underlying bassline.
SeedRnd (JNKM_SongSeed*1024)+JNKM_PatternAt+JNKM_SongAt+skip
For fm=1 To (JNKM_SongAt*4)+skip;fn=Rand(0,1000);Next
ftxt$="";ftxt2$=""

	ftxt$=JNKM_Set$[Rand(1,JNKM_Many[4])+4000]
	
	fs=Rand(0,2)

'	DebugLog fs+":"+ftxt$+":"+JNKM_Stretch[4]
	
	ftxt2$=ftxt$
	
	' expand it's length..
	If (JNKM_Stretch[4]>0 And fs>0) Or (JNKM_Stretch[4]<0)
		ftxt2$=""
'		DebugLog "stretch 4"
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf
	
	' expand it's length..
	If (JNKM_Stretch[4]=2 And fs=2) Or (JNKM_Stretch[4]=-2)
		ftxt$=ftxt2$
		ftxt2$=""
		For fn=1 To Len(ftxt$)
			ftxt2$=ftxt2$+Mid$(ftxt$,fn,1)+" "
		Next
	EndIf

Return ftxt2$
End Function







Function JNKM_NoteVal#(note$)
Select Lower$(note$)
	Case "z" Return 1/2
	Case "s" Return 1.059/2
	Case "x" Return 1.122/2
	Case "d" Return 1.189/2
	Case "c" Return 1.260/2
	Case "v" Return 1.335/2
	Case "g" Return 1.414/2
	Case "b" Return 1.498/2
	Case "h" Return 1.587/2
	Case "n" Return 1.682/2
	Case "j" Return 1.782/2
	Case "m" Return 1.888/2
	Case "q" Return 1
	Case "2" Return 1.059
	Case "w" Return 1.122
	Case "3" Return 1.189
	Case "e" Return 1.260
	Case "r" Return 1.335
	Case "5" Return 1.414
	Case "t" Return 1.498
	Case "6" Return 1.587
	Case "y" Return 1.682
	Case "7" Return 1.782
	Case "u" Return 1.888
	Case "i" Return 1*2
	Case "9" Return 1.059*2
	Case "o" Return 1.122*2
	Case "0" Return 1.189*2
	Case "p" Return 1.260*2
	Case "[" Return 1.335*2
	Case "=" Return 1.414*2
	Case "]" Return 1.498*2
End Select
End Function